Skip to main content

List of User Notifications

GET 

/notifications/v1/user-notifications

Early Access Request Access To User Notifications API v1

Retrieve a sorted, filtered, paginated list of all user notifications.

Request

Responses

User Notification.

Response Headers
    X-Request-Id

    The unique identifier for the API request.

    X-RateLimit-Limit

    The maximum number of requests you're permitted to make per time period.

    X-RateLimit-Remaining

    The number of requests remaining in the current rate limit window.

    X-RateLimit-Reset

    The relative time in seconds until the current rate-limit window resets.

    Important: This differs from Github and Twitter's same-named header which uses UTC epoch seconds. We use relative time to avoid client/server time synchronization issues.

OpenAPI definition (YAML)
paths:
  /notifications/v1/user-notifications:
    get:
      x-lifecycle-stage: Early Access
      x-self-access: false
      x-request-access-name: User Notifications API v1
      operationId: listNotificationsV1UserNotifications
      description: '[![Early Access](https://img.shields.io/badge/Lifecycle%20Stage-Early%20Access-%2345c6e8)](#section/Versioning/API-Lifecycle-Policy)
        [![Request Access To User Notifications API v1](https://img.shields.io/badge/-Request%20Access%20To%20User%20Notifications%20API%20v1-%23bc8540)](mailto:ccloud-api-access+notifications-v1-early-access@confluent.io?subject=Request%20to%20join%20notifications/v1%20API%20Early%20Access&body=I%E2%80%99d%20like%20to%20join%20the%20Confluent%20Cloud%20API%20Early%20Access%20for%20notifications/v1%20to%20provide%20early%20feedback%21%20My%20Cloud%20Organization%20ID%20is%20%3Cretrieve%20from%20https%3A//confluent.cloud/settings/billing/payment%3E.)


        Retrieve a sorted, filtered, paginated list of all user notifications.'
      parameters:
      - name: read
        in: query
        required: false
        schema:
          type: boolean
          description: Filter for whether this value is true or false.
          title: BooleanFilter
        description: Filter the results where read is true or false.
      - name: severity
        in: query
        required: false
        schema:
          description: Filter a collection by a string search for one or more values
          type: array
          items:
            type: string
          title: MultipleSearchFilter
        example:
        - CRITICAL
        - WARN
        description: 'Filter notifications by severity. Pass the parameter multiple

          times to match any of the given values

          (`?severity=CRITICAL&severity=WARN`). A notification matches if

          its `severity` equals any of the listed values.

          '
        style: form
        explode: true
      - name: include
        in: query
        required: false
        schema:
          description: Filter a collection by a string search
          type: string
          title: SearchFilter
        example: integrations,recommended_actions
        description: 'Comma-separated list of optional fields to populate in the response

          items. Allowed values: `integrations`, `recommended_actions`. By

          default these fields are omitted from list responses to keep

          collection payloads slim; set this parameter to opt in. This is a

          partial-response selector, not a value filter.

          '
      - name: resource.type
        in: query
        required: false
        schema:
          description: Filter a collection by a string search for one or more values
          type: array
          items:
            type: string
          title: MultipleSearchFilter
        example:
        - CLUSTER
        - CONNECTOR
        description: 'Filter notifications by the Confluent Cloud resource type they

          relate to. Pass the parameter multiple times to match any of the

          given values (`?resource.type=CLUSTER&resource.type=CONNECTOR`).

          A notification matches if its `resource.type` equals any of the

          listed values.

          '
        style: form
        explode: true
      - name: resource.crn
        in: query
        required: false
        schema:
          description: Filter a collection by a string search for one or more values
          type: array
          items:
            type: string
          title: MultipleSearchFilter
        example:
        - crn://confluent.cloud/organization=org-abc/environment=env-xyz/cloud-cluster=lkc-ds23ad
        - crn://confluent.cloud/organization=org-abc/environment=env-mx05q
        description: 'Filter notifications by the CRN of the Confluent Cloud resource they

          relate to. Pass the parameter multiple times to match any of the

          given CRNs; a notification matches if its `resource.crn` equals any

          of the listed values.

          '
        style: form
        explode: true
      - name: search
        in: query
        required: false
        schema:
          description: Filter a collection by a string search
          type: string
          title: SearchFilter
        example: cluster failure
        description: 'Free-text partial-match search across the embedded notification

          type''s `display_name` and `description`.

          '
      - name: time_range
        in: query
        required: false
        schema:
          description: Filter a collection by a string search
          type: string
          title: SearchFilter
        example: PAST_24H
        description: 'Filter notifications by a preset time window relative to now. Allowed

          values: `PAST_24H` (last 24 hours), `PAST_7D` (last 7 days), `PAST_30D`

          (last 30 days).

          '
      - name: page_size
        in: query
        required: false
        schema:
          type: integer
          default: 100
          maximum: 250
          x-max-page-items: 500
        description: A pagination size for collection requests.
      - name: page_token
        in: query
        required: false
        schema:
          type: string
          maxLength: 255
        description: An opaque pagination token for collection requests.
      - name: sort
        in: query
        required: false
        schema:
          type: array
          items:
            type: string
            enum:
            - severity
            - -severity
            - received_at
            - -received_at
          default:
          - -received_at
        description: The list of fields and directions that are used to sort the collection.
        style: form
        explode: false
      tags:
      - User Notifications (notifications/v1)
      security:
      - cloud-api-key: []
      - confluent-sts-access-token: []
      responses:
        '200':
          description: User Notification.
          content:
            application/json:
              schema:
                allOf:
                - type: object
                  description: "`UserNotification` objects represent in-app notifications scoped to a\
                    \ specific\nConfluent Cloud user. Each notification carries a severity, references\
                    \ the\nConfluent Cloud resource it relates to, and tracks whether the user has read\
                    \ it.\n\nThis API lets you list and retrieve your notifications, mark notifications\
                    \ as\nread or unread, and fetch an unread-count summary.\n\n`read` is the only mutable\
                    \ field on this resource; `PATCH` requests with values\nfor other fields will have\
                    \ those values silently ignored.\n\nTwo `PATCH` shapes are supported:\n- `PATCH /user-notifications/{id}`\
                    \ — update a single notification by id.\n- `PATCH /user-notifications` — update the\
                    \ read state of every notification\n  matching the supplied filter query parameters.\
                    \ The body is a narrow\n  payload (`{ \"read\": true | false }`) and the same filters\
                    \ accepted by\n  the list endpoint scope which notifications are updated (with the\n\
                    \  exception of `include`, which is a list-only partial-response selector).\n\nThe\
                    \ heavier `integrations` and `recommended_actions` fields are populated on\nsingle-resource\
                    \ reads (`GET /user-notifications/{id}`) and omitted from list\nresponses by default\
                    \ to keep collection payloads slim. Use the `include`\nquery parameter on the list\
                    \ endpoint to opt in to populating these fields\n(`?include=integrations,recommended_actions`).\n\
                    \n\nRelated guide: [Cloud Notifications](https://docs.confluent.io/cloud/current/monitoring/configure-notifications.html#notifications-for-ccloud).\n"
                  required:
                  - api_version
                  - kind
                  - metadata
                  - data
                  properties:
                    api_version:
                      type: string
                      enum:
                      - notifications/v1
                      description: APIVersion defines the schema version of this representation of a resource.
                      readOnly: true
                    kind:
                      type: string
                      description: Kind defines the object this REST resource represents.
                      readOnly: true
                      enum:
                      - UserNotificationList
                    metadata:
                      allOf:
                      - type: object
                        description: ListMeta describes metadata that resource collections may have
                        properties:
                          first:
                            description: A link to the first page of results. If a response does not contain
                              a first link, then direct navigation to the first page is not supported.
                            type: string
                            format: uri
                            nullable: true
                            example: https://api.confluent.cloud/v2/resourcekinds
                          last:
                            description: A link to the last page of results. If a response does not contain
                              a last link, then direct navigation to the last page is not supported.
                            type: string
                            format: uri
                            nullable: true
                            example: https://api.confluent.cloud/v2/resourcekinds?page_token=bcAOehAY8F16YD84Z1wT
                          prev:
                            description: A link to the previous page of results. If a response does not
                              contain a prev link, then either there is no previous data or backwards
                              traversal through the result set is not supported.
                            type: string
                            format: uri
                            nullable: true
                            example: https://api.confluent.cloud/v2/resourcekinds?page_token=YIXRY97wWYmwzrax4dld
                          next:
                            description: A link to the next page of results. If a response does not contain
                              a next link, then there is no more data available.
                            type: string
                            format: uri
                            nullable: true
                            example: https://api.confluent.cloud/v2/resourcekinds?page_token=UvmDWOB1iwfAIBPj6EYb
                          total_size:
                            description: Number of records in the full result set. This response may be
                              paginated and have a smaller number of records.
                            type: integer
                            format: int32
                            minimum: 0
                            example: 123
                        title: ListMeta
                      - properties:
                          first:
                            example: https://api.confluent.cloud/notifications/v1/user-notifications
                          last:
                            example: https://api.confluent.cloud/notifications/v1/user-notifications?page_token=bcAOehAY8F16YD84Z1wT
                          prev:
                            example: https://api.confluent.cloud/notifications/v1/user-notifications?page_token=YIXRY97wWYmwzrax4dld
                          next:
                            example: https://api.confluent.cloud/notifications/v1/user-notifications?page_token=UvmDWOB1iwfAIBPj6EYb
                    data:
                      type: array
                      description: A data property that contains an array of resource items. Each entry
                        in the array is a separate resource.
                      items:
                        allOf:
                        - type: object
                          description: "`UserNotification` objects represent in-app notifications scoped\
                            \ to a specific\nConfluent Cloud user. Each notification carries a severity,\
                            \ references the\nConfluent Cloud resource it relates to, and tracks whether\
                            \ the user has read it.\n\nThis API lets you list and retrieve your notifications,\
                            \ mark notifications as\nread or unread, and fetch an unread-count summary.\n\
                            \n`read` is the only mutable field on this resource; `PATCH` requests with\
                            \ values\nfor other fields will have those values silently ignored.\n\nTwo\
                            \ `PATCH` shapes are supported:\n- `PATCH /user-notifications/{id}` — update\
                            \ a single notification by id.\n- `PATCH /user-notifications` — update the\
                            \ read state of every notification\n  matching the supplied filter query parameters.\
                            \ The body is a narrow\n  payload (`{ \"read\": true | false }`) and the same\
                            \ filters accepted by\n  the list endpoint scope which notifications are updated\
                            \ (with the\n  exception of `include`, which is a list-only partial-response\
                            \ selector).\n\nThe heavier `integrations` and `recommended_actions` fields\
                            \ are populated on\nsingle-resource reads (`GET /user-notifications/{id}`)\
                            \ and omitted from list\nresponses by default to keep collection payloads\
                            \ slim. Use the `include`\nquery parameter on the list endpoint to opt in\
                            \ to populating these fields\n(`?include=integrations,recommended_actions`).\n\
                            \n\nRelated guide: [Cloud Notifications](https://docs.confluent.io/cloud/current/monitoring/configure-notifications.html#notifications-for-ccloud).\n"
                          properties:
                            api_version:
                              type: string
                              enum:
                              - notifications/v1
                              description: APIVersion defines the schema version of this representation
                                of a resource.
                              readOnly: true
                            kind:
                              type: string
                              description: Kind defines the object this REST resource represents.
                              readOnly: true
                              enum:
                              - UserNotification
                            id:
                              description: ID is the "natural identifier" for an object within its scope/namespace;
                                it is normally unique across time but not space. That is, you can assume
                                that the ID will not be reclaimed and reused after an object is deleted
                                ("time"); however, it may collide with IDs for other object `kinds` or
                                objects of the same `kind` within a different scope/namespace ("space").
                              type: string
                              maxLength: 255
                              readOnly: true
                              example: dlz-f3a90de
                            metadata:
                              allOf:
                              - description: ObjectMeta is metadata that all persisted resources must
                                  have, which includes all objects users must create.
                                required:
                                - self
                                properties:
                                  self:
                                    description: Self is a Uniform Resource Locator (URL) at which an
                                      object can be addressed. This URL encodes the service location,
                                      API version, and other particulars necessary to locate the resource
                                      at a point in time
                                    type: string
                                    format: uri
                                    readOnly: true
                                    example: https://api.confluent.cloud/v2/kafka-clusters/lkc-f3a90de
                                  resource_name:
                                    description: Resource Name is a Uniform Resource Identifier (URI)
                                      that is globally unique across space and time. It is represented
                                      as a Confluent Resource Name
                                    type: string
                                    format: uri
                                    readOnly: true
                                    example: crn://confluent.cloud/kafka=lkc-f3a90de
                                  created_at:
                                    type: string
                                    format: date-time
                                    example: '2006-01-02T15:04:05-07:00'
                                    readOnly: true
                                    description: The date and time at which this object was created. It
                                      is represented in RFC3339 format and is in UTC.
                                  updated_at:
                                    type: string
                                    format: date-time
                                    example: '2006-01-02T15:04:05-07:00'
                                    readOnly: true
                                    description: The date and time at which this object was last updated.
                                      It is represented in RFC3339 format and is in UTC.
                                  deleted_at:
                                    type: string
                                    format: date-time
                                    example: '2006-01-02T15:04:05-07:00'
                                    readOnly: true
                                    description: The date and time at which this object was (or will be)
                                      deleted. It is represented in RFC3339 format and is in UTC.
                                readOnly: true
                                title: ObjectMeta
                              - properties:
                                  self:
                                    example: https://api.confluent.cloud/notifications/v1/user-notifications/un-12345
                                  resource_name:
                                    example: crn://confluent.cloud/organization=9bb441c4-edef-46ac-8a41-c49e44a3fd9a/user-notification=un-12345
                            read:
                              type: boolean
                              description: Whether the notification has been read by the user.
                              example: false
                            read_at:
                              type: string
                              format: date-time
                              nullable: true
                              description: The time the notification was marked as read, or `null` if
                                it is unread.
                              example: '2026-01-31T11:00:00Z'
                              readOnly: true
                            severity:
                              type: string
                              description: 'The severity level of the notification.

                                - CRITICAL: a high impact notification which needs immediate attention.

                                - WARN: a warning notification which can be addressed now or later.

                                - INFO: an informational notification.

                                '
                              example: CRITICAL
                              readOnly: true
                              enum:
                              - CRITICAL
                              - WARN
                              - INFO
                            received_at:
                              type: string
                              format: date-time
                              description: The time the underlying event was generated.
                              example: '2026-01-31T10:35:00Z'
                              readOnly: true
                            resource:
                              description: 'The Confluent Cloud resource this notification relates to,
                                embedded

                                as a point-in-time snapshot at delivery time. Values remain accurate

                                even if the underlying resource is later renamed or deleted.

                                '
                              allOf:
                              - type: object
                                x-minispec-transform-ignore: true
                                description: 'Point-in-time snapshot of the Confluent Cloud resource a
                                  `UserNotification`

                                  relates to. Captured at delivery; values remain stable even if the

                                  underlying resource is later renamed or deleted.

                                  '
                                required:
                                - type
                                - crn
                                - display_name
                                properties:
                                  type:
                                    type: string
                                    description: The type of Confluent Cloud resource this notification
                                      relates to.
                                    example: CLUSTER
                                    enum:
                                    - ORGANIZATION
                                    - ENVIRONMENT
                                    - CLUSTER
                                    - CONNECTOR
                                    - TOPIC
                                    - FLINK_COMPUTE_POOL
                                    - FLINK_STATEMENT
                                    - CONNECTOR__CUSTOM_CONNECTOR
                                  crn:
                                    type: string
                                    description: CRN of the Confluent Cloud resource at delivery time.
                                    example: crn://confluent.cloud/organization=org-abc/environment=env-xyz/kafka-cluster=lkc-ds23ad
                                  display_name:
                                    type: string
                                    description: 'Human-readable name of the resource captured at notification
                                      time.

                                      Does not update if the underlying resource is later renamed.

                                      '
                                    example: prod-kafka-cluster
                                title: notifications.v1.ResourceSnapshot
                              readOnly: true
                            actions:
                              type: array
                              minItems: 1
                              items:
                                type: object
                                x-minispec-transform-ignore: true
                                description: 'A user-facing action associated with a `UserNotification`.
                                  The first

                                  action on a notification is treated as the primary action; subsequent

                                  actions are secondary.

                                  '
                                required:
                                - identifier
                                - url
                                - role
                                properties:
                                  identifier:
                                    type: string
                                    description: 'Stable identifier for the action, suitable for analytics.
                                      Stable

                                      across notification deliveries that recommend the same action.

                                      '
                                    example: manage_cluster_settings
                                  url:
                                    type: string
                                    format: uri
                                    description: Confluent Cloud URL this action navigates to.
                                    example: https://confluent.cloud/environments/env-xyz/clusters/lkc-ds23ad/settings
                                  role:
                                    type: string
                                    description: 'Visual prominence of the action. `PRIMARY` is the recommended

                                      default action; `SECONDARY` is shown alongside as a less prominent

                                      option.

                                      '
                                    example: PRIMARY
                                    enum:
                                    - PRIMARY
                                    - SECONDARY
                                title: notifications.v1.NotificationAction
                              description: 'Ordered list of user-facing actions associated with this notification.

                                The first entry is the primary action (`role: PRIMARY`) and is always

                                present; subsequent entries are secondary. Cardinality is open-ended —

                                additional actions may be added over time without a breaking schema

                                change.

                                '
                              readOnly: true
                            notification_type:
                              description: 'The notification type that triggered this notification, embedded
                                as

                                a point-in-time snapshot at delivery time so values remain accurate

                                even if the underlying `NotificationType` is later modified.

                                '
                              allOf:
                              - type: object
                                description: 'The type of notifications (and their corresponding metadata)
                                  supported by Confluent.



                                  Related guide: [Cloud Notifications](https://docs.confluent.io/cloud/current/monitoring/configure-notifications.html#notifications-for-ccloud).

                                  '
                                properties:
                                  api_version:
                                    type: string
                                    enum:
                                    - notifications/v1
                                    description: APIVersion defines the schema version of this representation
                                      of a resource.
                                    readOnly: true
                                  kind:
                                    type: string
                                    description: Kind defines the object this REST resource represents.
                                    readOnly: true
                                    enum:
                                    - NotificationType
                                  id:
                                    description: ID is the "natural identifier" for an object within its
                                      scope/namespace; it is normally unique across time but not space.
                                      That is, you can assume that the ID will not be reclaimed and reused
                                      after an object is deleted ("time"); however, it may collide with
                                      IDs for other object `kinds` or objects of the same `kind` within
                                      a different scope/namespace ("space").
                                    type: string
                                    maxLength: 255
                                    readOnly: true
                                    example: dlz-f3a90de
                                  metadata:
                                    allOf:
                                    - description: ObjectMeta is metadata that all persisted resources
                                        must have, which includes all objects users must create.
                                      required:
                                      - self
                                      properties:
                                        self:
                                          description: Self is a Uniform Resource Locator (URL) at which
                                            an object can be addressed. This URL encodes the service location,
                                            API version, and other particulars necessary to locate the
                                            resource at a point in time
                                          type: string
                                          format: uri
                                          readOnly: true
                                          example: https://api.confluent.cloud/v2/kafka-clusters/lkc-f3a90de
                                        resource_name:
                                          description: Resource Name is a Uniform Resource Identifier
                                            (URI) that is globally unique across space and time. It is
                                            represented as a Confluent Resource Name
                                          type: string
                                          format: uri
                                          readOnly: true
                                          example: crn://confluent.cloud/kafka=lkc-f3a90de
                                        created_at:
                                          type: string
                                          format: date-time
                                          example: '2006-01-02T15:04:05-07:00'
                                          readOnly: true
                                          description: The date and time at which this object was created.
                                            It is represented in RFC3339 format and is in UTC.
                                        updated_at:
                                          type: string
                                          format: date-time
                                          example: '2006-01-02T15:04:05-07:00'
                                          readOnly: true
                                          description: The date and time at which this object was last
                                            updated. It is represented in RFC3339 format and is in UTC.
                                        deleted_at:
                                          type: string
                                          format: date-time
                                          example: '2006-01-02T15:04:05-07:00'
                                          readOnly: true
                                          description: The date and time at which this object was (or
                                            will be) deleted. It is represented in RFC3339 format and
                                            is in UTC.
                                      readOnly: true
                                      title: ObjectMeta
                                    - properties:
                                        self:
                                          example: https://api.confluent.cloud/notifications/v1/notification-types/nt-12345
                                        resource_name:
                                          example: crn://confluent.cloud/organization=9bb441c4-edef-46ac-8a41-c49e44a3fd9a/notification-type=nt-12345
                                  display_name:
                                    type: string
                                    description: 'Human readable display name of the notification type

                                      '
                                    example: Cluster Shrink
                                  category:
                                    type: string
                                    description: "Represents the group with which the notification is\
                                      \ associated.\nNotifications are grouped under certain categories\
                                      \ for better organization.\n- BILLING_LICENSING: All billing, payments\
                                      \ or licensing related notifications are grouped here.\n- SECURITY:\
                                      \ All Confluent Cloud and Platform security related notifications\
                                      \ are grouped here.\n- SERVICE: All Confluent services (eg. Kafka,\
                                      \ Schema Registry, Connect etc.) related notifications are\n  grouped\
                                      \ here.\n- ACCOUNT: All Confluent account related notifications\
                                      \ are grouped here.\nFor example: Billing, payment or license related\
                                      \ notifications are grouped in BILLING_LICENSING category.\n"
                                    example: BILLING_LICENSING
                                    enum:
                                    - BILLING_LICENSING
                                    - SECURITY
                                    - SERVICE
                                    - ACCOUNT
                                  description:
                                    type: string
                                    description: 'Human readable description of the notification type

                                      '
                                    example: Cluster shrink operation is completed
                                  subscription_priority:
                                    type: string
                                    description: 'Indicates whether the notification is auto-subscribed
                                      and if the user can opt-out.

                                      - REQUIRED: the user is auto-subscribed to this notification and
                                      can''t opt-out.

                                      - RECOMMENDED: the user is auto-subscribed to this notification
                                      and can opt-out.

                                      - OPTIONAL: the user is not auto-subscribed to this notification
                                      but can explicitly subscribe to it.

                                      '
                                    example: REQUIRED
                                    enum:
                                    - REQUIRED
                                    - RECOMMENDED
                                    - OPTIONAL
                                  is_included_in_plan:
                                    type: boolean
                                    description: 'Whether this notification is available to subscribe
                                      or not

                                      as per the user''s current billing plan.

                                      '
                                  severity:
                                    type: string
                                    description: 'Severity indicates the impact of this notification.

                                      - CRITICAL: a high impact notification which needs immediate attention.

                                      - WARN: a warning notification which can be addressed now or later.

                                      - INFO: an informational notification.

                                      '
                                    example: INFO
                                    enum:
                                    - CRITICAL
                                    - WARN
                                    - INFO
                                  resource_type:
                                    type: string
                                    description: 'The type of resource this notification is associated
                                      with. Optional field.

                                      '
                                    example: CONNECTOR
                                    enum:
                                    - ORGANIZATION
                                    - ENVIRONMENT
                                    - CLUSTER
                                    - CONNECTOR
                                    - TOPIC
                                    - FLINK_COMPUTE_POOL
                                    - FLINK_STATEMENT
                                    - CONNECTOR__CUSTOM_CONNECTOR
                                title: notifications.v1.NotificationType
                              readOnly: true
                            integrations:
                              type: array
                              items:
                                type: object
                                description: 'You can create an `Integration` to specify how we can notify
                                  you when we receive an alert/notification for

                                  a subscription. Please note that you can only perform create, update
                                  and delete operations for integrations

                                  of type `Webhook`, `Slack` and `MsTeams`. You cannot create, update
                                  or delete integrations of type `RoleEmail`

                                  and `UserEmail`.



                                  Related guide: [Cloud Notifications](https://docs.confluent.io/cloud/current/monitoring/configure-notifications.html#notifications-for-ccloud).




                                  ## Quotas and Limits

                                  This resource is subject to the [following quotas](https://docs.confluent.io/cloud/current/quotas/overview.html):


                                  | Quota | Description |

                                  | --- | --- |

                                  | `integrations_per_org` | Maximum number of integrations in one Confluent
                                  Cloud organization |

                                  '
                                properties:
                                  api_version:
                                    type: string
                                    enum:
                                    - notifications/v1
                                    description: APIVersion defines the schema version of this representation
                                      of a resource.
                                    readOnly: true
                                  kind:
                                    type: string
                                    description: Kind defines the object this REST resource represents.
                                    readOnly: true
                                    enum:
                                    - Integration
                                  id:
                                    description: ID is the "natural identifier" for an object within its
                                      scope/namespace; it is normally unique across time but not space.
                                      That is, you can assume that the ID will not be reclaimed and reused
                                      after an object is deleted ("time"); however, it may collide with
                                      IDs for other object `kinds` or objects of the same `kind` within
                                      a different scope/namespace ("space").
                                    type: string
                                    maxLength: 255
                                    readOnly: true
                                    example: dlz-f3a90de
                                  metadata:
                                    allOf:
                                    - description: ObjectMeta is metadata that all persisted resources
                                        must have, which includes all objects users must create.
                                      required:
                                      - self
                                      properties:
                                        self:
                                          description: Self is a Uniform Resource Locator (URL) at which
                                            an object can be addressed. This URL encodes the service location,
                                            API version, and other particulars necessary to locate the
                                            resource at a point in time
                                          type: string
                                          format: uri
                                          readOnly: true
                                          example: https://api.confluent.cloud/v2/kafka-clusters/lkc-f3a90de
                                        resource_name:
                                          description: Resource Name is a Uniform Resource Identifier
                                            (URI) that is globally unique across space and time. It is
                                            represented as a Confluent Resource Name
                                          type: string
                                          format: uri
                                          readOnly: true
                                          example: crn://confluent.cloud/kafka=lkc-f3a90de
                                        created_at:
                                          type: string
                                          format: date-time
                                          example: '2006-01-02T15:04:05-07:00'
                                          readOnly: true
                                          description: The date and time at which this object was created.
                                            It is represented in RFC3339 format and is in UTC.
                                        updated_at:
                                          type: string
                                          format: date-time
                                          example: '2006-01-02T15:04:05-07:00'
                                          readOnly: true
                                          description: The date and time at which this object was last
                                            updated. It is represented in RFC3339 format and is in UTC.
                                        deleted_at:
                                          type: string
                                          format: date-time
                                          example: '2006-01-02T15:04:05-07:00'
                                          readOnly: true
                                          description: The date and time at which this object was (or
                                            will be) deleted. It is represented in RFC3339 format and
                                            is in UTC.
                                      readOnly: true
                                      title: ObjectMeta
                                    - properties:
                                        self:
                                          example: https://api.confluent.cloud/notifications/v1/integrations/i-12345
                                        resource_name:
                                          example: crn://confluent.cloud/organization=9bb441c4-edef-46ac-8a41-c49e44a3fd9a/integration=i-12345
                                  display_name:
                                    type: string
                                    maxLength: 64
                                    description: 'A human readable name for the particular integration

                                      '
                                    example: Slack integration
                                  description:
                                    type: string
                                    maxLength: 128
                                    description: 'A human readable description for the particular integration

                                      '
                                    example: A Slack channel integration
                                  target:
                                    description: 'Integration-specific details (integration targets)

                                      '
                                    allOf:
                                    - description: Target for the particular integration
                                      oneOf:
                                      - type: object
                                        description: Target required for Slack integration
                                        required:
                                        - kind
                                        - webhook_url
                                        properties:
                                          kind:
                                            type: string
                                            enum:
                                            - Slack
                                            description: Integration Type
                                            example: Slack
                                          webhook_url:
                                            type: string
                                            format: uri
                                            description: Slack Webhook URL for the particular Slack channel
                                            example: https://hooks.slack.com/services/{id}/{id}/{id}
                                        title: notifications.v1.SlackTarget
                                      - type: object
                                        description: Email integration target to send email to all user
                                          with specified role
                                        required:
                                        - kind
                                        - role_name
                                        properties:
                                          kind:
                                            type: string
                                            enum:
                                            - RoleEmail
                                            description: Email Integration type for Role
                                            example: RoleEmail
                                          role_name:
                                            type: string
                                            description: name of the role
                                            example: OrganizationAdmin
                                        title: notifications.v1.RoleEmailTarget
                                      - type: object
                                        description: Email integration target to send email to a particular
                                          user
                                        required:
                                        - kind
                                        - user
                                        properties:
                                          kind:
                                            type: string
                                            enum:
                                            - UserEmail
                                            description: Email Integration type for User
                                            example: UserEmail
                                          user:
                                            allOf:
                                            - type: object
                                              description: ObjectReference provides information for you
                                                to locate the referred object
                                              required:
                                              - id
                                              - related
                                              - resource_name
                                              properties:
                                                id:
                                                  type: string
                                                  description: ID of the referred resource
                                                  minLength: 1
                                                  maxLength: 255
                                                related:
                                                  type: string
                                                  format: uri
                                                  description: API URL for accessing or modifying the
                                                    referred object
                                                  minLength: 1
                                                  readOnly: true
                                                resource_name:
                                                  type: string
                                                  format: uri
                                                  description: CRN reference to the referred resource
                                                  minLength: 1
                                                  readOnly: true
                                              title: GlobalObjectReference
                                            description: Reference to the user
                                        title: notifications.v1.UserEmailTarget
                                      - type: object
                                        description: Target required for webhook integration
                                        required:
                                        - kind
                                        - url
                                        properties:
                                          kind:
                                            type: string
                                            enum:
                                            - Webhook
                                            description: Integration Type
                                            example: Webhook
                                          url:
                                            type: string
                                            format: uri
                                            description: URL endpoint for the webhook
                                            example: https://my.webhook.url/{id}
                                        title: notifications.v1.WebhookTarget
                                      - type: object
                                        description: Target required for MS Teams integration
                                        required:
                                        - kind
                                        - webhook_url
                                        properties:
                                          kind:
                                            type: string
                                            enum:
                                            - MsTeams
                                            description: Integration Type
                                            example: MsTeams
                                          webhook_url:
                                            type: string
                                            format: uri
                                            description: MS Teams Webhook URL for the particular team
                                              channel
                                            example: https://admin.webhook.office.com/webhookb2/{id}/IncomingWebhook/{id}
                                        title: notifications.v1.MsTeamsTarget
                                      - type: object
                                        description: Per-user in-app notification target; lazy-onboarded
                                          on first read.
                                        required:
                                        - kind
                                        - user
                                        properties:
                                          kind:
                                            type: string
                                            enum:
                                            - InApp
                                            description: Integration Type
                                            example: InApp
                                          user:
                                            allOf:
                                            - type: object
                                              description: ObjectReference provides information for you
                                                to locate the referred object
                                              required:
                                              - id
                                              - related
                                              - resource_name
                                              properties:
                                                id:
                                                  type: string
                                                  description: ID of the referred resource
                                                  minLength: 1
                                                  maxLength: 255
                                                related:
                                                  type: string
                                                  format: uri
                                                  description: API URL for accessing or modifying the
                                                    referred object
                                                  minLength: 1
                                                  readOnly: true
                                                resource_name:
                                                  type: string
                                                  format: uri
                                                  description: CRN reference to the referred resource
                                                  minLength: 1
                                                  readOnly: true
                                              title: GlobalObjectReference
                                            description: Reference to the user the in-app target belongs
                                              to.
                                        title: notifications.v1.InAppTarget
                                      discriminator:
                                        propertyName: kind
                                        mapping:
                                          Slack:
                                            type: object
                                            description: Target required for Slack integration
                                            required:
                                            - kind
                                            - webhook_url
                                            properties:
                                              kind:
                                                type: string
                                                enum:
                                                - Slack
                                                description: Integration Type
                                                example: Slack
                                              webhook_url:
                                                type: string
                                                format: uri
                                                description: Slack Webhook URL for the particular Slack
                                                  channel
                                                example: https://hooks.slack.com/services/{id}/{id}/{id}
                                            title: notifications.v1.SlackTarget
                                          RoleEmail:
                                            type: object
                                            description: Email integration target to send email to all
                                              user with specified role
                                            required:
                                            - kind
                                            - role_name
                                            properties:
                                              kind:
                                                type: string
                                                enum:
                                                - RoleEmail
                                                description: Email Integration type for Role
                                                example: RoleEmail
                                              role_name:
                                                type: string
                                                description: name of the role
                                                example: OrganizationAdmin
                                            title: notifications.v1.RoleEmailTarget
                                          UserEmail:
                                            type: object
                                            description: Email integration target to send email to a particular
                                              user
                                            required:
                                            - kind
                                            - user
                                            properties:
                                              kind:
                                                type: string
                                                enum:
                                                - UserEmail
                                                description: Email Integration type for User
                                                example: UserEmail
                                              user:
                                                allOf:
                                                - type: object
                                                  description: ObjectReference provides information for
                                                    you to locate the referred object
                                                  required:
                                                  - id
                                                  - related
                                                  - resource_name
                                                  properties:
                                                    id:
                                                      type: string
                                                      description: ID of the referred resource
                                                      minLength: 1
                                                      maxLength: 255
                                                    related:
                                                      type: string
                                                      format: uri
                                                      description: API URL for accessing or modifying
                                                        the referred object
                                                      minLength: 1
                                                      readOnly: true
                                                    resource_name:
                                                      type: string
                                                      format: uri
                                                      description: CRN reference to the referred resource
                                                      minLength: 1
                                                      readOnly: true
                                                  title: GlobalObjectReference
                                                description: Reference to the user
                                            title: notifications.v1.UserEmailTarget
                                          Webhook:
                                            type: object
                                            description: Target required for webhook integration
                                            required:
                                            - kind
                                            - url
                                            properties:
                                              kind:
                                                type: string
                                                enum:
                                                - Webhook
                                                description: Integration Type
                                                example: Webhook
                                              url:
                                                type: string
                                                format: uri
                                                description: URL endpoint for the webhook
                                                example: https://my.webhook.url/{id}
                                            title: notifications.v1.WebhookTarget
                                          MsTeams:
                                            type: object
                                            description: Target required for MS Teams integration
                                            required:
                                            - kind
                                            - webhook_url
                                            properties:
                                              kind:
                                                type: string
                                                enum:
                                                - MsTeams
                                                description: Integration Type
                                                example: MsTeams
                                              webhook_url:
                                                type: string
                                                format: uri
                                                description: MS Teams Webhook URL for the particular team
                                                  channel
                                                example: https://admin.webhook.office.com/webhookb2/{id}/IncomingWebhook/{id}
                                            title: notifications.v1.MsTeamsTarget
                                          InApp:
                                            type: object
                                            description: Per-user in-app notification target; lazy-onboarded
                                              on first read.
                                            required:
                                            - kind
                                            - user
                                            properties:
                                              kind:
                                                type: string
                                                enum:
                                                - InApp
                                                description: Integration Type
                                                example: InApp
                                              user:
                                                allOf:
                                                - type: object
                                                  description: ObjectReference provides information for
                                                    you to locate the referred object
                                                  required:
                                                  - id
                                                  - related
                                                  - resource_name
                                                  properties:
                                                    id:
                                                      type: string
                                                      description: ID of the referred resource
                                                      minLength: 1
                                                      maxLength: 255
                                                    related:
                                                      type: string
                                                      format: uri
                                                      description: API URL for accessing or modifying
                                                        the referred object
                                                      minLength: 1
                                                      readOnly: true
                                                    resource_name:
                                                      type: string
                                                      format: uri
                                                      description: CRN reference to the referred resource
                                                      minLength: 1
                                                      readOnly: true
                                                  title: GlobalObjectReference
                                                description: Reference to the user the in-app target belongs
                                                  to.
                                            title: notifications.v1.InAppTarget
                                      example:
                                        kind: Slack
                                        webhook_url: https://hooks.slack.com/services/{id}/{id}/{id}
                                      title: notifications.v1.Target
                                title: notifications.v1.Integration
                              description: 'The integrations this notification was delivered to. Each
                                entry is a

                                point-in-time snapshot of the integration at delivery time, so values

                                remain accurate even if the underlying `Integration` is later

                                modified or deleted. Populated on single-resource reads

                                (`GET /user-notifications/{id}`); omitted from list responses.

                                '
                              readOnly: true
                            recommended_actions:
                              description: 'Versioned payload describing the recommended actions a user
                                can take

                                in response to this notification. The shape is stable per `version`

                                and consumers should branch on `version` when deserializing.

                                Populated on single-resource reads (`GET /user-notifications/{id}`);

                                omitted from list responses.

                                '
                              allOf:
                              - type: object
                                description: 'Versioned payload describing the recommended actions a user
                                  can take in

                                  response to a `UserNotification`. The shape is stable per `version`
                                  and

                                  consumers should branch on `version` when deserializing.

                                  '
                                required:
                                - version
                                - content
                                properties:
                                  version:
                                    type: integer
                                    format: int32
                                    description: 'Schema version of the `recommended_actions` payload.
                                      Increment when

                                      the payload shape changes in a non-backward-compatible way.

                                      '
                                    example: 1
                                  content:
                                    type: string
                                    description: 'Human-readable body text describing the recommended
                                      actions.

                                      Rendered as Markdown for `version: 1`.

                                      '
                                    example: Restart the cluster from the Confluent Cloud console.
                                title: notifications.v1.RecommendedActions
                              readOnly: true
                          title: notifications.v1.UserNotification
                        - type: object
                          required:
                          - id
                          - metadata
                          - read
                          - received_at
                          - resource
                          - actions
                          - notification_type
                      uniqueItems: true
                  title: notifications.v1.UserNotificationList
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
            X-RateLimit-Limit:
              schema:
                type: integer
              description: The maximum number of requests you're permitted to make per time period.
            X-RateLimit-Remaining:
              schema:
                type: integer
              description: The number of requests remaining in the current rate limit window.
            X-RateLimit-Reset:
              schema:
                type: integer
              description: "The relative time in seconds until the current rate-limit window resets. \
                \ \n  \n**Important:** This differs from Github and Twitter's same-named header which\
                \ uses UTC epoch seconds. We use relative time to avoid client/server time synchronization\
                \ issues."
        '400':
          description: Bad Request
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
          content:
            application/json:
              schema:
                type: object
                description: Provides information about problems encountered while performing an operation.
                required:
                - errors
                properties:
                  errors:
                    description: List of errors which caused this operation to fail
                    type: array
                    items:
                      type: object
                      description: Describes a particular error encountered while performing an operation.
                      properties:
                        id:
                          description: A unique identifier for this particular occurrence of the problem.
                          type: string
                          maxLength: 255
                        status:
                          description: The HTTP status code applicable to this problem, expressed as a
                            string value.
                          type: string
                        code:
                          description: An application-specific error code, expressed as a string value.
                          type: string
                        title:
                          description: A short, human-readable summary of the problem. It **SHOULD NOT**
                            change from occurrence to occurrence of the problem, except for purposes of
                            localization.
                          type: string
                        detail:
                          description: A human-readable explanation specific to this occurrence of the
                            problem.
                          type: string
                        source:
                          type: object
                          description: If this error was caused by a particular part of the API request,
                            the source will point to the query string parameter or request body property
                            that caused it.
                          properties:
                            pointer:
                              description: A JSON Pointer [RFC6901] to the associated entity in the request
                                document [e.g. "/spec" for a spec object, or "/spec/title" for a specific
                                field].
                              type: string
                            parameter:
                              description: A string indicating which query parameter caused the error.
                              type: string
                        error_code:
                          type: integer
                          format: int32
                        message:
                          type: string
                          nullable: true
                      additionalProperties: false
                      title: Error
                    uniqueItems: true
                title: Failure
              example:
                errors:
                - id: ed42afdc-f0d5-4c0d-b428-9fc6ed6e279d
                  status: '400'
                  code: invalid_filter
                  title: Invalid Filter
                  detail: The 'delorean' resource can't be filtered by 'num_doors'
                  source:
                    parameter: num_doors
        '401':
          x-summary: Unauthorized
          description: The request lacks valid authentication credentials for this resource.
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
            WWW-Authenticate:
              schema:
                type: string
              description: The unique identifier for the API request.
              example: Basic error="invalid_key", error_description="The API Key is invalid"
          content:
            application/json:
              schema:
                type: object
                description: Provides information about problems encountered while performing an operation.
                required:
                - errors
                properties:
                  errors:
                    description: List of errors which caused this operation to fail
                    type: array
                    items:
                      type: object
                      description: Describes a particular error encountered while performing an operation.
                      properties:
                        id:
                          description: A unique identifier for this particular occurrence of the problem.
                          type: string
                          maxLength: 255
                        status:
                          description: The HTTP status code applicable to this problem, expressed as a
                            string value.
                          type: string
                        code:
                          description: An application-specific error code, expressed as a string value.
                          type: string
                        title:
                          description: A short, human-readable summary of the problem. It **SHOULD NOT**
                            change from occurrence to occurrence of the problem, except for purposes of
                            localization.
                          type: string
                        detail:
                          description: A human-readable explanation specific to this occurrence of the
                            problem.
                          type: string
                        source:
                          type: object
                          description: If this error was caused by a particular part of the API request,
                            the source will point to the query string parameter or request body property
                            that caused it.
                          properties:
                            pointer:
                              description: A JSON Pointer [RFC6901] to the associated entity in the request
                                document [e.g. "/spec" for a spec object, or "/spec/title" for a specific
                                field].
                              type: string
                            parameter:
                              description: A string indicating which query parameter caused the error.
                              type: string
                        error_code:
                          type: integer
                          format: int32
                        message:
                          type: string
                          nullable: true
                      additionalProperties: false
                      title: Error
                    uniqueItems: true
                title: Failure
              example:
                errors:
                - id: ed42afdc-f0d5-4c0d-b428-9fc6ed6e279d
                  status: '401'
                  code: user_unauthenticated
                  title: Authentication Required
                  detail: Valid authentication credentials must be provided
        '403':
          x-summary: Forbidden
          description: The access credentials were considered insufficient to grant access
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
          content:
            application/json:
              schema:
                type: object
                description: Provides information about problems encountered while performing an operation.
                required:
                - errors
                properties:
                  errors:
                    description: List of errors which caused this operation to fail
                    type: array
                    items:
                      type: object
                      description: Describes a particular error encountered while performing an operation.
                      properties:
                        id:
                          description: A unique identifier for this particular occurrence of the problem.
                          type: string
                          maxLength: 255
                        status:
                          description: The HTTP status code applicable to this problem, expressed as a
                            string value.
                          type: string
                        code:
                          description: An application-specific error code, expressed as a string value.
                          type: string
                        title:
                          description: A short, human-readable summary of the problem. It **SHOULD NOT**
                            change from occurrence to occurrence of the problem, except for purposes of
                            localization.
                          type: string
                        detail:
                          description: A human-readable explanation specific to this occurrence of the
                            problem.
                          type: string
                        source:
                          type: object
                          description: If this error was caused by a particular part of the API request,
                            the source will point to the query string parameter or request body property
                            that caused it.
                          properties:
                            pointer:
                              description: A JSON Pointer [RFC6901] to the associated entity in the request
                                document [e.g. "/spec" for a spec object, or "/spec/title" for a specific
                                field].
                              type: string
                            parameter:
                              description: A string indicating which query parameter caused the error.
                              type: string
                        error_code:
                          type: integer
                          format: int32
                        message:
                          type: string
                          nullable: true
                      additionalProperties: false
                      title: Error
                    uniqueItems: true
                title: Failure
              example:
                errors:
                - id: ed42afdc-f0d5-4c0d-b428-9fc6ed6e279d
                  status: '403'
                  code: user_unauthorized
                  title: User Access Unauthorized
                  detail: The user 'mcfly' is not allowed to access the 'delorean' resource without the
                    'plutonium' role.
        '429':
          description: Rate Limit Exceeded
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
            X-RateLimit-Limit:
              schema:
                type: integer
              description: The maximum number of requests you're permitted to make per time period.
            X-RateLimit-Remaining:
              schema:
                type: integer
              description: The number of requests remaining in the current rate limit window.
            X-RateLimit-Reset:
              schema:
                type: integer
              description: "The relative time in seconds until the current rate-limit window resets. \
                \ \n  \n**Important:** This differs from Github and Twitter's same-named header which\
                \ uses UTC epoch seconds. We use relative time to avoid client/server time synchronization\
                \ issues."
            Retry-After:
              schema:
                type: integer
              description: The number of seconds to wait until the rate limit window resets. Only sent
                when the rate limit is reached.
        '500':
          description: Oops, something went wrong!
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
          content:
            application/json:
              schema:
                type: object
                description: Provides information about problems encountered while performing an operation.
                required:
                - errors
                properties:
                  errors:
                    description: List of errors which caused this operation to fail
                    type: array
                    items:
                      type: object
                      description: Describes a particular error encountered while performing an operation.
                      properties:
                        id:
                          description: A unique identifier for this particular occurrence of the problem.
                          type: string
                          maxLength: 255
                        status:
                          description: The HTTP status code applicable to this problem, expressed as a
                            string value.
                          type: string
                        code:
                          description: An application-specific error code, expressed as a string value.
                          type: string
                        title:
                          description: A short, human-readable summary of the problem. It **SHOULD NOT**
                            change from occurrence to occurrence of the problem, except for purposes of
                            localization.
                          type: string
                        detail:
                          description: A human-readable explanation specific to this occurrence of the
                            problem.
                          type: string
                        source:
                          type: object
                          description: If this error was caused by a particular part of the API request,
                            the source will point to the query string parameter or request body property
                            that caused it.
                          properties:
                            pointer:
                              description: A JSON Pointer [RFC6901] to the associated entity in the request
                                document [e.g. "/spec" for a spec object, or "/spec/title" for a specific
                                field].
                              type: string
                            parameter:
                              description: A string indicating which query parameter caused the error.
                              type: string
                        error_code:
                          type: integer
                          format: int32
                        message:
                          type: string
                          nullable: true
                      additionalProperties: false
                      title: Error
                    uniqueItems: true
                title: Failure
              example:
                errors:
                - id: ed42afdc-f0d5-4c0d-b428-9fc6ed6e279d
                  status: '500'
                  code: out_of_gas
                  title: DeLorean Out Of Gas
                  detail: The DeLorean has run out of gas, but Doc Brown will fill 'er up for you asap
      servers:
      - url: https://api.confluent.cloud
        description: Confluent Cloud API